library(psych); library(GPArotation)

# uXL[f[^v̓ǂݍ
SDdat <- read.csv('dat/ski.csv', header=T, row.names=1)

# uXL[f[^v̈q
fa(SDdat, nfactors=3, rotate="varimax", fm="ml")      # o}bNX]
fa(SDdat, nfactors=3, rotate="quartimax", fm="ml")    # R[eB}bNX]
fa(SDdat, nfactors=3, rotate="geominT", fm="ml")      # WI~]
fa(SDdat, nfactors=3, rotate="promax", fm="ml")       # v}bNX]
fa(SDdat, nfactors=3, rotate="oblimin", fm="ml")      # Iu~]
fa(SDdat, nfactors=3, rotate="biquartimin", fm="ml")  # oCR[eB~]
fa(SDdat, nfactors=3, rotate="simplimax", fm="ml")    # Vv}bNX]
fa(SDdat, nfactors=3, rotate="geominQ", fm="ml")      # ΌWI~]

# uYGif[^v̓ǂݍ
YGdat <- read.csv('dat/YG3.csv', header=T, sep=',') 

# uYGif[^v̈q
fa(YGdat, nfactors=2, rotate="promax", fm="ml")       # v}bNX]
fa(YGdat, nfactors=2, rotate="oblimin", fm="ml")      # Iu~]
fa(YGdat, nfactors=2, rotate="simplimax", fm="ml")    # Vv}bNX]
fa(YGdat, nfactors=2, rotate="geominQ", fm="ml")      # ΌWI~]




